<?php
/**
 * Created by Stefan Warnat
 * User: Stefan
 * Date: 05.09.2017
 * Time: 10:41
 */

namespace SwVtTools;


class Plugin
{
    private static $_Register = array();

    public static function register($label, $callback, $options) {
        $trace = debug_backtrace(0, 2);

        $registrar = $trace[0]['file'];

        if(is_callable($callback)) {
            self::$_Register[md5($label . $registrar)] = array_merge($options, array(
                'label' => $label,
                'callback' => $callback
            ));
        } else {
            throw new \Exception('Callback of Plugin '.basename($registrar).' "'.$label.'" is not callable');
        }
    }

    public static function load() {
        if(!empty(self::$_Register)) return;

        $alle = glob(dirname(__FILE__).'/../../extends/functions/*.inc.php');
        foreach($alle as $datei) { include_once(realpath($datei)); }
    }

    public static function getAllPlugins() {
        self::load();
        return self::$_Register;
    }

    public static function run($key) {
        self::load();

        call_user_func(self::$_Register[$key]['callback']);
    }
}

